POS = 
{
	ITEM_X = 
	{
		SMALL = {2,12},
		MID = {3,16},
	},
	ITEM_Y = 
	{
		SMALL = {3,4,5,9,10,11},
		MID = {3,4,5,9,10,14,15,16},
	},
	SPAWN_X = 
	{
		SMALL = {(1*32+16),(13*32+16)},
		MID = {(2*32+16),(17*32+16)},
	},
	SPAWN_Y =
	{
		SMALL = {(4*32+16),(10*32+16)},
		MID = {(4*32+16),(10*32+16),(15*32+16)},
	},
}

WEAPON_LIST = 
{
	weapons =
	{
		10,
		22,24,
		30,32,31,33,38,39,
		34,35,
		91,
	},
	melee =
	{
		69,85,78,50
	},
}

MAP_TYPE =
{
	SMALL = 
	{
		WALL = 
		{
			X = 
			{
				3,4,10,11
			},
			Y =
			{
				3,4,5,9,10,11
			},
			OBSTACLE = 
			{
				{4,2,119},
				{10,1,115},
				{8,3,149},
				{9,4,149},
				{6,6,72},
				{7,6,73},
				{6,7,77},
				{7,7,78},
				{8,7,132},
				{7,8,133},
				{5,10,148},
				{7,12,53},
				{8,12,54},
				{7,13,58},
				{8,13,59},
			},
			TILE = 
			{
				{7,11,12},
				{6,11,12},
				{5,11,12},
				{4,12,12},
				{5,12,12},
				{6,12,12},
				{4,13,12},
				{5,13,12},
				{6,13,12},
				{8,1,12},
				{9,1,12},
				{11,1,12},
				{12,1,12},
				{7,2,12},
				{8,2,12},
				{9,2,12},
				{10,2,12},
				{11,2,12},
			}
		},
	},
	MID = 
	{
		WALL = 
		{
			X = 
			{
				4,5,6,7,12,13,14,15
			},
			Y =
			{
				7,12
			},
			OBSTACLE = 
			{
				{4,10,128},{4,9,128},{15,9,128},{15,10,128},
				{12,8,128},{7,8,128},{7,11,128},{12,11,128},
				{4,14,115},{9,17,148},{9,18,148},{10,18,148},
				{15,14,120},{4,5,119},{5,1,148},{13,2,133},
				{14,2,134},{14,5,149},
				{4,15,53},{5,15,54},{4,16,58},{5,16,59},
				{14,15,53},{15,15,54},{14,16,58},{15,16,59},
				{4,3,53},{5,3,54},{4,4,58},{5,4,59},
				{14,3,72},{15,3,73},{14,4,77},{15,4,77},	
			},
		},
		TILE =
		{
			BRIDGE_X = {7,8,9,10,11,12},
			BRIDGE_Y = {9,10},
			WHITE_X = {4,13},
			WHITE_MX = {6,15},
			WHITE_Y = {8,11},
		}
	},

}


MAP_SIZE = 1
GAME_MODE = { "Standard","Melee","Primary only","Secondary only" }

function CLEAR_MAP()
	for x =0,map("xsize") do
		for y = 0,map("ysize") do
		parse("settile "..x.." "..y.." 0")
		end
	end
	if MAP_SIZE == 1 then 
	MID_C()
	BIG_C()
	elseif MAP_SIZE == 2 then
	SMALL_C()
	BIG_C()
	elseif MAP_SIZE == 3 then
	SMALL_C()
	MID_C()
	end
end

function SMALL_C()
	for _,e in pairs(entitylist()) do
		if entity(e.x,e.y,"name")=="SMALL" and entity(e.x,e.y,"state")==false then
		parse("trigger SMALL")
		end
	end
end

function MID_C()
	for _,e in pairs(entitylist()) do
		if entity(e.x,e.y,"name")=="MID" and entity(e.x,e.y,"state")==false then
		parse("trigger MID")
		end
	end
end

function BIG_C()
	for _,e in pairs(entitylist()) do
		if entity(e.x,e.y,"name")=="BIG" and entity(e.x,e.y,"state")==false then
		parse("trigger BIG")
		end
	end
end

function MAP_BUILD()
CLEAR_MAP()
	if MAP_SIZE == 1 then
		for x = 0,14 do
			for y = 0,14 do
			parse("settile "..x.." "..y.." 13")
			parse("settile 0 "..y.." 104"); parse("settile 14 "..y.." 104")
			end
		parse("settile "..x.." 0 104"); parse("settile "..x.." 14 104")
		end
		for _,i in pairs(MAP_TYPE.SMALL.WALL.X)do
			for _,j in pairs(MAP_TYPE.SMALL.WALL.Y)do
			parse("settile "..i.." "..j.." 104")
			end
		end
		for i = 1,#MAP_TYPE.SMALL.WALL.OBSTACLE do
		parse("settile "..MAP_TYPE.SMALL.WALL.OBSTACLE[i][1].." "..MAP_TYPE.SMALL.WALL.OBSTACLE[i][2].." "..MAP_TYPE.SMALL.WALL.OBSTACLE[i][3])
		end
		for i = 1,#MAP_TYPE.SMALL.WALL.TILE do
		parse("settile "..MAP_TYPE.SMALL.WALL.TILE[i][1].." "..MAP_TYPE.SMALL.WALL.TILE[i][2].." "..MAP_TYPE.SMALL.WALL.TILE[i][3])
		end
		for _,e in pairs(entitylist()) do
			if entity(e.x,e.y,"name")=="SMALL" and entity(e.x,e.y,"state")==true then
			parse("trigger SMALL")
			end
		end
	BIG_C()
	MID_C()
	elseif MAP_SIZE==2 then -- SIZE 2
	SMALL_C()
	BIG_C()
		for _,e in pairs(entitylist()) do
			if entity(e.x,e.y,"name")=="SMALL" and entity(e.x,e.y,"state")==false then
			parse("trigger SMALL")
			end
		end
		for x = 0,19 do
			for y = 0,19 do
			parse("settile "..x.." "..y.." 6")
			parse("settile 0 "..y.." 104"); parse("settile 19 "..y.." 104")
			end
		parse("settile "..x.." 0 104"); parse("settile "..x.." 19 104")
		end
		for k,x in pairs(MAP_TYPE.MID.TILE.BRIDGE_X) do
			for k,y in pairs(MAP_TYPE.MID.TILE.BRIDGE_Y) do
			parse("settile "..x.." "..y.." 62")
			end
		end
		for x = MAP_TYPE.MID.TILE.WHITE_X[1],MAP_TYPE.MID.TILE.WHITE_MX[1] do
			for y = MAP_TYPE.MID.TILE.WHITE_Y[1],MAP_TYPE.MID.TILE.WHITE_Y[2] do
			parse("settile "..x.." "..y.." 9")
			end
		end
		for x = MAP_TYPE.MID.TILE.WHITE_X[2],MAP_TYPE.MID.TILE.WHITE_MX[2] do
			for y = MAP_TYPE.MID.TILE.WHITE_Y[1],MAP_TYPE.MID.TILE.WHITE_Y[2] do
			parse("settile "..x.." "..y.." 9")
			end
		end
		for _,i in pairs(MAP_TYPE.MID.WALL.X)do
			for _,j in pairs(MAP_TYPE.MID.WALL.Y)do
			print("\169230230230Settile at "..i.." "..j)
			parse("settile "..i.." "..j.." 128")
			end
		end
		for i = 1,#MAP_TYPE.MID.WALL.OBSTACLE do
		parse("settile "..MAP_TYPE.MID.WALL.OBSTACLE[i][1].." "..MAP_TYPE.MID.WALL.OBSTACLE[i][2].." "..MAP_TYPE.MID.WALL.OBSTACLE[i][3])
		end
		for _,e in pairs(entitylist()) do
			if entity(e.x,e.y,"name")=="MID" and entity(e.x,e.y,"state")==true then
			parse("trigger MID")
			end
		end
	end
end

addhook("spawn","AIM_spawn")
function AIM_spawn(id)
SPAWN_POINT()
end

function SPAWN_POINT()
	for _,id in pairs(player(0,"tableliving")) do
		if MAP_SIZE == 1 then
			if player(id,"team")==1 then
			parse("setpos "..id.." "..POS.SPAWN_X.SMALL[1].." "..POS.SPAWN_Y.SMALL[math.random(1,2)])
			elseif player(id,"team")==2 then
			parse("setpos "..id.." "..POS.SPAWN_X.SMALL[2].." "..POS.SPAWN_Y.SMALL[math.random(1,2)])
			end
		elseif MAP_SIZE == 2 then
			if player(id,"team")==1 then
			parse("setpos "..id.." "..POS.SPAWN_X.MID[1].." "..POS.SPAWN_Y.MID[math.random(1,3)])
			elseif player(id,"team")==2 then
			parse("setpos "..id.." "..POS.SPAWN_X.MID[2].." "..POS.SPAWN_Y.MID[math.random(1,3)])
			end
		end
	end
end
addhook("startround","AIM_startround")
function AIM_startround()
	if #player(0,"table")>6 and #player(0,"table")<10 then
	MAP_SIZE = 2
	elseif #player(0,"table")>10 then
	MAP_SIZE = 3
	else
	MAP_SIZE = 1
	end
SPAWN_POINT()
ROUND = math.random(1,4)
HG = math.random(1,6)
RANDOMWEAPON= WEAPON_LIST.weapons[math.random(1,12)]
RANDOMMELEE = WEAPON_LIST.melee[math.random(1,4)]
	if MAP_SIZE == 1 then
	I_X = POS.ITEM_X.SMALL
	I_Y = POS.ITEM_Y.SMALL
	elseif MAP_SIZE == 2 then
	I_X = POS.ITEM_X.MID
	I_Y = POS.ITEM_Y.MID
	elseif MAP_SIZE == 3 then
	I_X = POS.ITEM_X.BIG
	I_Y = POS.ITEM_Y.BIG
	end
WEAPON_FUNC()
GAME_INFO()
MAP_BUILD()
end


function GAME_INFO()
parse("hudtxt 1 \"\169116177132MODE : \169201196092"..GAME_MODE[ROUND].."\" 400 80 0")
	if ROUND == 1 then 
	msg("\169077162055Primary : \169190190190"..item(6,"name"))
	msg("\169188181082Secondary : \169190190190"..item(1,"name"))
	elseif ROUND == 3 then
	msg("\169077162055Primary : \169190190190"..item(1,"name"))
	elseif ROUND == 4 then
	msg("\169188181082Secondary : \169190190190"..item(1,"name"))
	elseif ROUND == 2 then
	msg("\169170170170Melee : \169190190190"..item(1,"name"))
	end
end


function WEAPON_FUNC()
	if ROUND == 1 then
		for _,x in pairs(I_X) do
			for _,y in pairs(I_Y) do
			parse("spawnitem "..HG.." "..x.." "..y)
			parse("spawnitem "..RANDOMWEAPON.." "..x.." "..y)
				for _,id in pairs(player(0,"tableliving")) do
				parse("setarmor "..id.." 100")
				end
			end
		end
	elseif ROUND == 2 then
		for _,x in pairs(I_X) do
			for _,y in pairs(I_Y) do
			parse("spawnitem "..RANDOMMELEE.." "..x.." "..y)
			end
		end
	elseif ROUND == 3 then
		for _,x in pairs(I_X) do
			for _,y in pairs(I_Y) do
			parse("spawnitem "..RANDOMWEAPON.." "..x.." "..y)
				for _,id in pairs(player(0,"tableliving")) do
				parse("setarmor "..id.." 100")
				end
			end
		end
	elseif ROUND == 4 then
		for _,x in pairs(I_X) do
			for _,y in pairs(I_Y) do
			parse("spawnitem "..HG.." "..x.." "..y)
				for _,id in pairs(player(0,"tableliving")) do
				parse("setarmor "..id.." 100")
				end
			end
		end
	end
end
AIM_startround()
